# 4nodes example
This is derived from 21/8/2018 version of https://github.com/blk-io/quorum-examples (commit 0cb4012945d707239c942617fdf44ab1c991a4c5). 

The intention is to directly compare a *dockerized* network with a *vagrant virtualbox* network; of each 4 nodes.

## changes 
* following all suggestions mentioned after comment https://github.com/blk-io/crux/issues/27#issuecomment-413540251 
* removed nodes 5, 6, 7
* see `git log` of this branch `4nodes` for details

## attempt to run


### on host system
```
git checkout -b 4nodes

vagrant destroy 
vagrant up

vagrant ssh
```

### within vagrant virtualbox
```
cd quorum-examples/
cd 4nodes
./istanbul-init.sh 
./istanbul-start.sh 
```

### log files

```
vagrant@ubuntu-xenial:~/quorum-examples/4nodes$ tail -n 1000 -f qdata/logs/1.log 

nohup: appending output to 'nohup.out'
INFO [08-21|09:59:50] Starting peer-to-peer node               instance=Geth/v1.7.2-stable-6d90ce86/linux-amd64/go1.9.3
INFO [08-21|09:59:50] Allocated cache and file handles         database=/home/vagrant/quorum-examples/4nodes/qdata/dd1/geth/chaindata cache=128 handles=1024
WARN [08-21|09:59:50] Upgrading database to use lookup entries 
INFO [08-21|09:59:50] Initialised chain configuration          config="{ChainID: <nil> Homestead: 1 DAO: <nil> DAOSupport: false EIP150: 2 EIP155: 3 EIP158: 3 Byzantium: <nil> IsQuorum: true Engine: istanbul}"
INFO [08-21|09:59:50] Initialising Ethereum protocol           versions="[63 62]" network=1
INFO [08-21|09:59:50] Loaded most recent local header          number=0 hash=62c2c0…5a3c94 td=1
INFO [08-21|09:59:50] Loaded most recent local full block      number=0 hash=62c2c0…5a3c94 td=1
INFO [08-21|09:59:50] Loaded most recent local fast block      number=0 hash=62c2c0…5a3c94 td=1
INFO [08-21|09:59:50] Regenerated local transaction journal    transactions=0 accounts=0
INFO [08-21|09:59:50] Database deduplication successful        deduped=0
INFO [08-21|09:59:50] Starting P2P networking 
INFO [08-21|09:59:52] UDP listener up                          self=enode://ac6b1096ca56b9f6d004b779ae3728bf83f8e22453404cc3cef16a3d9b96608bc67c4b30db88e0a5a6c6390213f7acbe1153ff6d23ce57380104288ae19373ef@[::]:21000
INFO [08-21|09:59:52] RLPx listener up                         self=enode://ac6b1096ca56b9f6d004b779ae3728bf83f8e22453404cc3cef16a3d9b96608bc67c4b30db88e0a5a6c6390213f7acbe1153ff6d23ce57380104288ae19373ef@[::]:21000
WARN [08-21|09:59:52] Removing static dial candidate           id=ac6b1096ca56b9f6 addr=127.0.0.1:21000 err="is self"
INFO [08-21|09:59:52] HTTP endpoint opened: http://0.0.0.0:22000 
INFO [08-21|09:59:52] IPC endpoint opened: /home/vagrant/quorum-examples/4nodes/qdata/dd1/geth.ipc 
INFO [08-21|09:59:53] Unlocked account                         address=0xed9d02e382b34818e88B88a309c7fe71E65f419d
INFO [08-21|09:59:53] Transaction pool price threshold updated price=18000000000
INFO [08-21|09:59:53] Starting mining operation 
INFO [08-21|09:59:53] Commit new mining work                   number=1 txs=0 uncles=0 elapsed=78.401µs
```

stuck there. Same for node 2.

Slightly different for node 3 and 4:

```
vagrant@ubuntu-xenial:~/quorum-examples/4nodes$ tail -n 1000 -f qdata/logs/3.log 
nohup: appending output to 'nohup.out'
WARN [08-21|09:59:50] No etherbase set and no accounts found as default 
INFO [08-21|09:59:50] Starting peer-to-peer node               instance=Geth/v1.7.2-stable-6d90ce86/linux-amd64/go1.9.3
INFO [08-21|09:59:50] Allocated cache and file handles         database=/home/vagrant/quorum-examples/4nodes/qdata/dd3/geth/chaindata cache=128 handles=1024
WARN [08-21|09:59:50] Upgrading database to use lookup entries 
INFO [08-21|09:59:50] Initialised chain configuration          config="{ChainID: <nil> Homestead: 1 DAO: <nil> DAOSupport: false EIP150: 2 EIP155: 3 EIP158: 3 Byzantium: <nil> IsQuorum: true Engine: istanbul}"
INFO [08-21|09:59:50] Initialising Ethereum protocol           versions="[63 62]" network=1
INFO [08-21|09:59:50] Loaded most recent local header          number=0 hash=62c2c0…5a3c94 td=1
INFO [08-21|09:59:50] Loaded most recent local full block      number=0 hash=62c2c0…5a3c94 td=1
INFO [08-21|09:59:50] Loaded most recent local fast block      number=0 hash=62c2c0…5a3c94 td=1
INFO [08-21|09:59:50] Regenerated local transaction journal    transactions=0 accounts=0
INFO [08-21|09:59:50] Starting P2P networking 
INFO [08-21|09:59:50] Database deduplication successful        deduped=0
INFO [08-21|09:59:52] UDP listener up                          self=enode://579f786d4e2830bbcc02815a27e8a9bacccc9605df4dc6f20bcc1a6eb391e7225fff7cb83e5b4ecd1f3a94d8b733803f2f66b7e871961e7b029e22c155c3a778@[::]:21002
INFO [08-21|09:59:52] HTTP endpoint opened: http://0.0.0.0:22002 
INFO [08-21|09:59:52] Transaction pool price threshold updated price=18000000000
INFO [08-21|09:59:52] Starting mining operation 
INFO [08-21|09:59:52] Commit new mining work                   number=1 txs=0 uncles=0 elapsed=94.912µs
INFO [08-21|09:59:52] RLPx listener up                         self=enode://579f786d4e2830bbcc02815a27e8a9bacccc9605df4dc6f20bcc1a6eb391e7225fff7cb83e5b4ecd1f3a94d8b733803f2f66b7e871961e7b029e22c155c3a778@[::]:21002
WARN [08-21|09:59:52] Removing static dial candidate           id=579f786d4e2830bb addr=127.0.0.1:21002 err="is self"
INFO [08-21|09:59:52] IPC endpoint opened: /home/vagrant/quorum-examples/4nodes/qdata/dd3/geth.ipc 
```

### attach JSRE

```
geth_quorum attach http://localhost:22000

Welcome to the Geth JavaScript console!
instance: Geth/v1.7.2-stable-6d90ce86/linux-amd64/go1.9.3
coinbase: 0xd8dba507e85f116b1f7e231ca8525fc9008a6966
at block: 0 (Thu, 01 Jan 1970 01:00:00 BST)
 datadir: /home/vagrant/quorum-examples/4nodes/qdata/dd1
 modules: admin:1.0 debug:1.0 eth:1.0 istanbul:1.0 miner:1.0 net:1.0 personal:1.0 rpc:1.0 txpool:1.0 web3:1.0

> eth.blockNumber
0

geth_quorum attach http://localhost:22001

Welcome to the Geth JavaScript console!
instance: Geth/v1.7.2-stable-6d90ce86/linux-amd64/go1.9.3
coinbase: 0x6571d97f340c8495b661a823f2c2145ca47d63c2
at block: 0 (Thu, 01 Jan 1970 01:00:00 BST)
 datadir: /home/vagrant/quorum-examples/4nodes/qdata/dd2
 modules: admin:1.0 debug:1.0 eth:1.0 istanbul:1.0 miner:1.0 net:1.0 personal:1.0 rpc:1.0 txpool:1.0 web3:1.0

> eth.blockNumber
0


geth_quorum attach http://localhost:22002

Welcome to the Geth JavaScript console!
instance: Geth/v1.7.2-stable-6d90ce86/linux-amd64/go1.9.3
coinbase: 0xe36cbeb565b061217930767886474e3cde903ac5
at block: 0 (Thu, 01 Jan 1970 01:00:00 BST)
 datadir: /home/vagrant/quorum-examples/4nodes/qdata/dd3
 modules: admin:1.0 debug:1.0 eth:1.0 istanbul:1.0 miner:1.0 net:1.0 personal:1.0 rpc:1.0 txpool:1.0 web3:1.0

> eth.blockNumber
0

geth_quorum attach http://localhost:22003

Welcome to the Geth JavaScript console!
instance: Geth/v1.7.2-stable-6d90ce86/linux-amd64/go1.9.3
coinbase: 0xf512a992f3fb749857d758ffda1330e590fa915e
at block: 0 (Thu, 01 Jan 1970 01:00:00 BST)
 datadir: /home/vagrant/quorum-examples/4nodes/qdata/dd4
 modules: admin:1.0 debug:1.0 eth:1.0 istanbul:1.0 miner:1.0 net:1.0 personal:1.0 rpc:1.0 txpool:1.0 web3:1.0

> eth.blockNumber
0

geth_quorum attach http://localhost:22004
Fatal: Failed to start the JavaScript console: api modules: Post http://localhost:22004: EOF
```

## problem
chain is not moving
